## lib25519 0~20230630

=== crypto_hashblocks/sha512/avx2/Makefile ===
inner.S: \
round01.q \
round23.q \
round45.q \
round67.q \
round89.q \
round1011.q \
round1213.q \
round1415.q \
expand0.q \
expand4.q \
expand8.q \
expand12.q \
rer0.q \
rer4.q \
rer8.q \
rer12.q \
inner.q \
inner.S.do
	./inner.S.do < inner.q > inner.S

round01.q: round.py
	./round.py 0 > round01.q

round23.q: round.py
	./round.py 1 > round23.q

round45.q: round.py
	./round.py 2 > round45.q

round67.q: round.py
	./round.py 3 > round67.q

round89.q: round.py
	./round.py 4 > round89.q

round1011.q: round.py
	./round.py 5 > round1011.q

round1213.q: round.py
	./round.py 6 > round1213.q

round1415.q: round.py
	./round.py 7 > round1415.q

expand0.q: expand.py
	./expand.py 0 > expand0.q

expand4.q: expand.py
	./expand.py 4 > expand4.q

expand8.q: expand.py
	./expand.py 8 > expand8.q

expand12.q: expand.py
	./expand.py 12 > expand12.q

rer0.q: rer.py
	./rer.py 0 > rer0.q

rer4.q: rer.py
	./rer.py 4 > rer4.q

rer8.q: rer.py
	./rer.py 8 > rer8.q

rer12.q: rer.py
	./rer.py 12 > rer12.q

=== crypto_pow/inv25519/ref10/Makefile ===
all: montgomery.h pow225521.h

pow225521.h: pow225521.q pow225521.h.do
	./pow225521.h.do < pow225521.q > pow225521.h

=== debian/changelog ===
lib25519 (0~20230630-4) unstable; urgency=medium

  * d/copyright: bump debian/* copyright year
  * d/gbp.conf: add [pull] track-missing = True
  * d/control: remove 'Multi-Arch: same' for the package lib25519-dev,
    lib25519-dev contains the lib25519.h header file, which is different
    across platforms.

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 08 Jan 2024 09:31:53 +0100

lib25519 (0~20230630-3) unstable; urgency=medium

  * d/rules: select crypto_hashblocks/sha512/inplace implementation
    instead of crypto_hashblocks/sha512/wflip
  * d/control: add Multi-Arch: same

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sun, 31 Dec 2023 18:52:43 +0100

lib25519 (0~20230630-2) unstable; urgency=medium

  * d/compiler/gcc: Echo commands for blhc.
  * d/rules add DEB_BUILD_MAINT_OPTIONS = optimize=+lto
  * d/watch: use special strings @PACKAGE@, @ANY_VERSION@, @ARCHIVE_EXT@
  * d/rules: detect the correct ABINAME from the DEB_BUILD_ARCH
    instead of run-time detection. Fixes FTBR on i386/armhf/...
  * d/p/0100-FTBR-sort-ofiles.patch: sort the output of os.listdir()
  * d/lib25519-1.symbols.x32: add symbolic link to lib25519-1.symbols.amd64
  * d/rules: enable selected AMD64 implementations

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sat, 30 Dec 2023 14:57:06 +0100

lib25519 (0~20230630-1) unstable; urgency=medium

  * Initial release. (Closes: #1051553)

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 11 Sep 2023 17:29:24 +0200

=== debian/control ===
Source: lib25519
Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Priority: optional
Standards-Version: 4.6.2
Section: libs
Homepage: https://lib25519.cr.yp.to/download.html
Build-Depends:
 debhelper-compat (= 13),
 libcpucycles-dev,
 librandombytes-dev,
 python3,
Vcs-Git: https://salsa.debian.org/debian/lib25519.git
Vcs-Browser: https://salsa.debian.org/debian/lib25519
Rules-Requires-Root: no

Package: ed25519
Section: devel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: microlibrary X25519/Ed25519 - Ed25519 command line tools
 microlibrary for the X25519 encryption system and the Ed25519 signature system,
 both of which use the Curve25519 elliptic curve. Curve25519 is the fastest
 curve in TLS 1.3, and the only curve in Wireguard, Signal, and many other
 applications.
 .
 lib25519 has a very simple stateless API based on the SUPERCOP API, with
 wire-format inputs and outputs, providing functions that directly match the
 central cryptographic operations in X25519 and Ed25519:
 .
 lib25519_dh_keypair(pk, sk): X25519 key generation
 lib25519_dh(k, pk, sk): shared-secret generation
 lib25519_sign_keypair(pk, sk): Ed25519 key generation
 lib25519_sign(sm, &smlen, m, mlen, sk): signing
 lib25519_sign_open(m, &mlen, sm, smlen, pk): verification + message recovery
 Internally, lib25519 includes implementations designed for performance on
 various CPUs, implementations designed to work portably across CPUs, and
 automatic run-time selection of implementations.
 .
 lib25519 is intended to be called by larger multi-function libraries, including
 libraries in other languages via FFI. The idea is that lib25519 will take
 responsibility for the details of X25519/Ed25519 computation, including
 optimization, timing-attack protection, and eventually verification, freeing up
 the calling libraries to concentrate on application-specific needs such as
 protocol integration. Applications can also call lib25519 directly.
 .
 Ed25519 command line tools.

Package: lib25519-1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: microlibrary X25519/Ed25519 - shared library
 microlibrary for the X25519 encryption system and the Ed25519 signature system,
 both of which use the Curve25519 elliptic curve. Curve25519 is the fastest
 curve in TLS 1.3, and the only curve in Wireguard, Signal, and many other
 applications.
 .
 lib25519 has a very simple stateless API based on the SUPERCOP API, with
 wire-format inputs and outputs, providing functions that directly match the
 central cryptographic operations in X25519 and Ed25519:
 .
 lib25519_dh_keypair(pk, sk): X25519 key generation
 lib25519_dh(k, pk, sk): shared-secret generation
 lib25519_sign_keypair(pk, sk): Ed25519 key generation
 lib25519_sign(sm, &smlen, m, mlen, sk): signing
 lib25519_sign_open(m, &mlen, sm, smlen, pk): verification + message recovery
 Internally, lib25519 includes implementations designed for performance on
 various CPUs, implementations designed to work portably across CPUs, and
 automatic run-time selection of implementations.
 .
 lib25519 is intended to be called by larger multi-function libraries, including
 libraries in other languages via FFI. The idea is that lib25519 will take
 responsibility for the details of X25519/Ed25519 computation, including
 optimization, timing-attack protection, and eventually verification, freeing up
 the calling libraries to concentrate on application-specific needs such as
 protocol integration. Applications can also call lib25519 directly.
 .
 Shared library.

Package: lib25519-dev
Section: libdevel
Architecture: any
Depends:
 lib25519-1 (= ${binary:Version}),
 ${misc:Depends},
Description: microlibrary X25519/Ed25519 - development files
 microlibrary for the X25519 encryption system and the Ed25519 signature system,
 both of which use the Curve25519 elliptic curve. Curve25519 is the fastest
 curve in TLS 1.3, and the only curve in Wireguard, Signal, and many other
 applications.
 .
 lib25519 has a very simple stateless API based on the SUPERCOP API, with
 wire-format inputs and outputs, providing functions that directly match the
 central cryptographic operations in X25519 and Ed25519:
 .
 lib25519_dh_keypair(pk, sk): X25519 key generation
 lib25519_dh(k, pk, sk): shared-secret generation
 lib25519_sign_keypair(pk, sk): Ed25519 key generation
 lib25519_sign(sm, &smlen, m, mlen, sk): signing
 lib25519_sign_open(m, &mlen, sm, smlen, pk): verification + message recovery
 Internally, lib25519 includes implementations designed for performance on
 various CPUs, implementations designed to work portably across CPUs, and
 automatic run-time selection of implementations.
 .
 lib25519 is intended to be called by larger multi-function libraries, including
 libraries in other languages via FFI. The idea is that lib25519 will take
 responsibility for the details of X25519/Ed25519 computation, including
 optimization, timing-attack protection, and eventually verification, freeing up
 the calling libraries to concentrate on application-specific needs such as
 protocol integration. Applications can also call lib25519 directly.
 .
 Development files.

Package: x25519
Section: devel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: microlibrary X25519/Ed25519 - X25519 command line tools
 microlibrary for the X25519 encryption system and the Ed25519 signature system,
 both of which use the Curve25519 elliptic curve. Curve25519 is the fastest
 curve in TLS 1.3, and the only curve in Wireguard, Signal, and many other
 applications.
 .
 lib25519 has a very simple stateless API based on the SUPERCOP API, with
 wire-format inputs and outputs, providing functions that directly match the
 central cryptographic operations in X25519 and Ed25519:
 .
 lib25519_dh_keypair(pk, sk): X25519 key generation
 lib25519_dh(k, pk, sk): shared-secret generation
 lib25519_sign_keypair(pk, sk): Ed25519 key generation
 lib25519_sign(sm, &smlen, m, mlen, sk): signing
 lib25519_sign_open(m, &mlen, sm, smlen, pk): verification + message recovery
 Internally, lib25519 includes implementations designed for performance on
 various CPUs, implementations designed to work portably across CPUs, and
 automatic run-time selection of implementations.
 .
 lib25519 is intended to be called by larger multi-function libraries, including
 libraries in other languages via FFI. The idea is that lib25519 will take
 responsibility for the details of X25519/Ed25519 computation, including
 optimization, timing-attack protection, and eventually verification, freeing up
 the calling libraries to concentrate on application-specific needs such as
 protocol integration. Applications can also call lib25519 directly.
 .
 X25519 command line tools.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack

# crossbuild
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
include /usr/share/dpkg/buildtools.mk
endif

%:
	dh $@

# In the debian/compiler directory contains gcc and clang wrappers.
# It adds Debian specifific options distributed in
# $CC, $CFLAGS, $CPPFLAGS and $LDFLAGS
export PATH := $(shell pwd)/debian/compiler:$(PATH)

# Detects the correct ABINAME from the DEB_BUILD_ARCH
# instead of run-time detection. Fixes FTBR.
ABINAME=$(DEB_BUILD_ARCH)
ifeq ($(ABINAME), x32)
ABINAME=amd64
endif

.PHONY: select_implementations
select_implementations:
	# disable all implementations
	ls -1d crypto_*/*/* \
	| while read d; \
	do \
	  chmod +t "$${d}"; \
	done
	# enable portable implementations
	chmod -t crypto_dh/x25519/wrapper
	chmod -t crypto_hash/sha512/ref
	chmod -t crypto_hashblocks/sha512/inplace
	chmod -t crypto_mGnP/ed25519/ref10
	chmod -t crypto_multiscalar/ed25519/ref10
	chmod -t crypto_nG/montgomery25519/usemerged
	chmod -t crypto_nG/merged25519/ref10
	chmod -t crypto_nP/montgomery25519/ref10
	chmod -t crypto_nPbatch/montgomery25519/ref
	chmod -t crypto_pow/inv25519/ref10
	chmod -t crypto_powbatch/inv25519/ref10
	chmod -t crypto_sign/ed25519/ref10
	chmod -t crypto_verify/32/ref
	# enable amd64 implementations
	chmod -t crypto_sign/ed25519/amd64
	chmod -t crypto_mGnP/ed25519/amd64-maa4
	chmod -t crypto_multiscalar/ed25519/amd64-maa4
	chmod -t crypto_nG/merged25519/amd64-maa4
	chmod -t crypto_nP/montgomery25519/amd64-maa4
	chmod -t crypto_pow/inv25519/amd64-maa4
	# enable amd64 avx2 implementations
	chmod -t crypto_hash/sha512/blocksplusavx
	chmod -t crypto_hashblocks/sha512/avx2
	chmod -t crypto_mGnP/ed25519/amd64-avx2-9l-mxaa
	chmod -t crypto_multiscalar/ed25519/amd64-avx2-9l-mxaa-p3
	chmod -t crypto_nG/merged25519/amd64-avx2-9l-mxaa
	chmod -t crypto_nP/montgomery25519/amd64-avx2-ns10l-mxaa
	chmod -t crypto_nPbatch/montgomery25519/amd64-avx2-4x1-10l-mxaa
	chmod -t crypto_pow/inv25519/amd64-safegcd
	# enable amd64 avx512 implementations
	chmod -t crypto_multiscalar/ed25519/amd64-avx512ifma-5l-maax-p3
	chmod -t crypto_nG/merged25519/amd64-avx512ifma-5l-maax
	chmod -t crypto_nP/montgomery25519/amd64-avx512ifma-ns5l-maax
	chmod -t crypto_nPbatch/montgomery25519/amd64-avx512ifma-8x1-maax

override_dh_auto_configure: select_implementations
	./configure --host=$(ABINAME) --prefix=/usr

override_dh_auto_clean:
	rm -rf ./build

# disable auto installation
override_dh_auto_install:

=== debian/tests/control ===
Tests: test25519-static
Depends:
 build-essential,
 dpkg-dev,
 lib25519-dev,
 librandombytes-dev,

Tests: test25519-shared
Depends:
 build-essential,
 dpkg-dev,
 lib25519-1,
 lib25519-dev,
 librandombytes-dev,

Tests: ed25519
Depends:
 ed25519,
 xxd,

Tests: x25519
Depends:
 x25519,
 xxd,

## lib25519 0~20240321

=== debian/changelog ===
lib25519 (0~20240321-2) unstable; urgency=medium

  * d/rules: run test lib25519-test
  * d/rules: disable donna_c64 implementations, fix build/autopkgtest on s390x

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Wed, 24 Apr 2024 19:53:05 +0200

lib25519 (0~20240321-1) unstable; urgency=medium

  [ Simon Josefsson ]
  * New upstream version 0~20240321
  * Add ABIs to symbols files.
  * Add d/salsa-ci.yml for wrap-and-sort.

  [ Jan Mojžíš ]
  * d/copyright: bump lib25519 copyright years
  * d/p/0002-remove-internal-_C-symbols-from-.symbol-file.patch add
  * d/p/0003-fix-missing-asm-hidden.patch add
  * d/lib25519-1.symbols.{amd64,x32} remove
  * d/rules: remove manual selection and enable all implementation

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 22 Apr 2024 14:51:50 +0200

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack

# crossbuild
ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
include /usr/share/dpkg/buildtools.mk
endif

%:
	dh $@

# The debian/compiler directory contains gcc and clang wrappers.
# It adds Debian specifific options distributed in
# $CC, $CFLAGS, $CPPFLAGS and $LDFLAGS
export PATH := $(shell pwd)/debian/compiler:$(PATH)

# Detects the correct ABINAME from the DEB_BUILD_ARCH
# instead of run-time detection. Fixes FTBR.
ABINAME=$(DEB_BUILD_ARCH)
ifeq ($(ABINAME), x32)
ABINAME=amd64
endif

override_dh_auto_configure:
	# disable donna_c64 implementations, fixes build/autopkgtest on s390x
	chmod +t crypto_nP/montgomery25519/donna_c64 crypto_pow/inv25519/donna_c64
	./configure --host=$(ABINAME) --prefix=/usr

override_dh_auto_clean:
	rm -rf ./build

# disable auto installation
override_dh_auto_install:

# run lib25519-test
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	env "LD_LIBRARY_PATH=$$LD_LIBRARY_PATH:./build/0/package/lib" ./build/0/package/bin/lib25519-test
endif

## lib25519 0~20241004

=== crypto_hashblocks/sha512/m3/Makefile ===
all: inner.inc inner32.S

inner32.S: inner32.q copy-collector align inner32.S.do
	sh inner32.S.do > inner32.S

inner32.q: inner.q inner32.top inner32.desc inner32.q.do
	sh inner32.q.do > inner32.q

inner.inc: inner.q inner.top inner.desc inner.c.do
	sh inner.c.do > inner.inc

=== crypto_hashblocks/sha512/m4inline/Makefile ===
all: inner.inc inner32.S

inner32.S: inner32.q copy-collector align
	qhasm-arm-m4 < inner32.q | ./copy-collector | ./align | sed 's/\<inner\>/CRYPTO_SHARED_NAMESPACE(inner)/' > inner32.S

inner32.q: inner.q inner32.top inner32.desc inner32.q.do
	sh inner32.q.do > inner32.q

inner.inc: inner.q inner.top inner.desc inner.c.do
	sh inner.c.do > inner.inc

=== crypto_hashblocks/sha512/m4mult/Makefile ===
all: inner32.S

inner32.S: inner32.q copy-collector align
	qhasm-arm-m4 < inner32.q | ./copy-collector | ./align | sed 's/\<inner\>/CRYPTO_SHARED_NAMESPACE(inner)/' > inner32.S

inner32.q: inner.q inner32.desc inner32.q.do inner32.top
	sh inner32.q.do > inner32.q

=== crypto_hashblocks/sha512/m4nofpu/Makefile ===
all: inner32.S

inner32.S: inner32.q copy-collector align inner32.S.do
	sh inner32.S.do > inner32.S

inner32.q: inner.q inner32.desc inner32.q.do inner32.top
	sh inner32.q.do > inner32.q

=== crypto_mGnP/ed25519/ref10/Makefile ===
all: d.h d2.h sqrtm1.h base.h base2.h \
ge_add.h ge_sub.h \
ge_madd.h ge_msub.h \
ge_p2_dbl.h \
pow225521.h pow22523.h

d.h: d.py
	python d.py > d.h

d2.h: d2.py
	python d2.py > d2.h

sqrtm1.h: sqrtm1.py
	python sqrtm1.py > sqrtm1.h

base.h: base.py
	python base.py > base.h

base2.h: base2.py
	python base2.py > base2.h

ge_add.h: ge_add.q q2h.sh
	./q2h.sh < ge_add.q > ge_add.h

ge_sub.h: ge_sub.q q2h.sh
	./q2h.sh < ge_sub.q > ge_sub.h

ge_madd.h: ge_madd.q q2h.sh
	./q2h.sh < ge_madd.q > ge_madd.h

ge_msub.h: ge_msub.q q2h.sh
	./q2h.sh < ge_msub.q > ge_msub.h

ge_p2_dbl.h: ge_p2_dbl.q q2h.sh
	./q2h.sh < ge_p2_dbl.q > ge_p2_dbl.h

pow22523.h: pow22523.q q2h.sh
	./q2h.sh < pow22523.q > pow22523.h

pow225521.h: pow225521.q q2h.sh
	./q2h.sh < pow225521.q > pow225521.h

=== crypto_nP/montgomery25519/ref10/Makefile ===
all: montgomery.h pow225521.h

pow225521.h: pow225521.q pow225521.h.do
	./pow225521.h.do < pow225521.q > pow225521.h

montgomery.h: montgomery.q montgomery.h.do
	./montgomery.h.do < montgomery.q > montgomery.h

=== crypto_pow/inv25519/amd64-safegcd/Makefile ===
CC=clang -O3 -march=native -Wall

test: test.o asm.o table.o
	$(CC) -o test test.o asm.o table.o -lgmp

test.o: test.c
	$(CC) -c test.c

asm.o: asm.s
	$(CC) -c asm.s

table.o: table.c
	$(CC) -c table.c

=== debian/changelog ===
lib25519 (0~20241004-4) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/watch: rewrite to version 5
  * d/control: remove Rules-Requires-Root: no

  [ Simon Josefsson ]
  * Re-generate manpages.
  * Add lrc.excludes.
  * Tighten Salsa CI.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 02 Nov 2025 20:45:37 +0100

lib25519 (0~20241004-3) unstable; urgency=medium

  * d/control: change maintainer to pkg-security
  * d/{control, copyright}: update my email to "janmojzis@debian.org"
  * d/copyright: bump debian/* copyright year

 -- Jan Mojžíš <janmojzis@debian.org>  Tue, 19 Aug 2025 07:09:37 +0200

lib25519 (0~20241004-2) unstable; urgency=medium

  * d/salsa-ci.yml: Enable arm/riscv/aptly jobs.
  * Run wrap-and-sort -satbk.
  * Standards-Version: 4.7.2.
  * Bump debian/* copyright years.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 09 Mar 2025 20:36:16 +0100

lib25519 (0~20241004-1) unstable; urgency=medium

  * New upstream version 0~20241004
  * d/rules: re-enable crypto_hashblocks/sha512/wflip, fixed in upstream
  * d/p/0001-add-missing-include-build-crypto_declassify.h.patch: remove,
    fixed in upstream

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Sat, 05 Oct 2024 12:19:24 +0200

lib25519 (0~20240928-2) unstable; urgency=medium

  * d/rules: disable crypto_hashblocks/sha512/wflip implementation, fix
    lib25519-test on s390x/hppa/powerpc/ppc64/sparc64
  * d/t/lib25519-fulltest: skip the test if valgrind is not available,
    add Restrictions allow-stderr, skippable

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Tue, 01 Oct 2024 20:56:47 +0200

lib25519 (0~20240928-1) unstable; urgency=medium

  * New upstream version 0~20240928
  * d/p/0002-remove-internal-_C-symbols-from-.symbol-file.patch,
    d/p/0003-fix-missing-asm-hidden.patch, d/p/0100-FTBR-sort-ofiles.patch
    remove, fixed in upstream
  * d/rules: re-enable donna_c64 implementations
  * d/rules: remove optimize=+lto
  * d/rules: B-D on valgrind-if-available
  * d/rules: check if valgrind is available
  * d/p/0001-add-missing-include-build-crypto_declassify.h.patch add
  * d/t/test25519-shared: use dpkg-buildflags to get CFLAGS,LDFLAGS
  * d/t/test25519-static: use dpkg-buildflags to get CFLAGS,LDFLAGS
  * d/control: bump Standards-Version: 4.7.0, no changes
  * d/gbp.conf: dist = DEP14, debian-branch = debian/latest
  * d/t/lib25519-fulltest add
  * d/upstream/metadata add

 -- Jan Mojžíš <jan.mojzis@gmail.com>  Mon, 30 Sep 2024 21:23:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: lib25519
-Maintainer: Jan Mojžíš <jan.mojzis@gmail.com>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
+ Jan Mojžíš <janmojzis@debian.org>,
  Simon Josefsson <simon@josefsson.org>,
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://lib25519.cr.yp.to/download.html
 Build-Depends:
  debhelper-compat (= 13),
  libcpucycles-dev,
  librandombytes-dev,
+ pandoc [!m68k !sh4 !x32] <!nodoc>,
  python3,
+ valgrind-if-available,
 Vcs-Git: https://salsa.debian.org/debian/lib25519.git
 Vcs-Browser: https://salsa.debian.org/debian/lib25519
-Rules-Requires-Root: no
 
 Package: ed25519
 Section: devel

=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,15 @@
 
 # export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,noexecstack
+
+# disable hardening-stackclash on armhf
+# On armhf, valgrind test dies with a SIGSEGV when
+# built with either -fstack-clash-protection or -fstack-check.
+ifeq ($(DEB_TARGET_ARCH), armhf)
+export DEB_BUILD_MAINT_OPTIONS = hardening=hardening=+all,-stackclash
+endif
 
 # crossbuild
 ifneq  ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
@@ -25,10 +32,19 @@
 ABINAME=amd64
 endif
 
+COMMAND_VALGRIND = $(shell command -v valgrind)
+
+ifeq ($(filter /usr/bin/valgrind,$(COMMAND_VALGRIND)),)
+DISABLE_VALGRIND += --no-valgrind
+endif
+
 override_dh_auto_configure:
-	# disable donna_c64 implementations, fixes build/autopkgtest on s390x
-	chmod +t crypto_nP/montgomery25519/donna_c64 crypto_pow/inv25519/donna_c64
-	./configure --host=$(ABINAME) --prefix=/usr
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	head -v $(shell find . -name x25519.1)
+	(! command -v pandoc) || (rm -v doc/man/* && autogen/man)
+	head -v $(shell find . -name x25519.1)
+endif
+	./configure --host=$(ABINAME) --prefix=/usr $(DISABLE_VALGRIND)
 
 override_dh_auto_clean:
 	rm -rf ./build

=== debian/watch ===
Version: 5
Source: https://lib25519.cr.yp.to/download.html
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
Uversion-Mangle: s/^/0~/
